/*  Copyright (c) 2024 by soruce <soruce ~ AT ~ soruce.net>

    This file is part of the Arduino PimientoClockLib Library.

    The Arduino PimientoClockLib Library is free software: you can redistribute it
    and/or modify it under the terms of the GNU General Public License as
    published by the Free Software Foundation, either version 3 of the
    License, or (at your option) any later version.

    The Arduino PimientoClockLib Library is distributed in the hope that it will be
    useful, but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with The Arduino PimientoClockLib Library.  If not, see
    <http://www.gnu.org/licenses/>.
*/

#ifndef FONT2_H
#define FONT2_H

#include <Arduino.h>
#include "IFont.h"

// TODO See https://int10h.org/oldschool-pc-fonts/fontlist/font?everexme_7x8 for a better font

class Font2 : public IFont {

  public:

    virtual uint8_t getCharWidth();
    virtual uint8_t getCharWidth(char c);
    virtual uint8_t getCharHeight();
    virtual char getColumnData(char c, uint8_t column);
    virtual uint8_t getSpacingBetweenChars();
  
  private:
    static const uint8_t CHAR_WIDTH = 8;
    static const uint8_t CHAR_HEIGHT = 8;
    static const uint8_t SPACING_BETWEEN_CHARS = 2;

    static const char START_CHAR = '0';
    static const char END_CHAR = '9';
    static const char UNKNOWN_CHAR = '0';
};

#endif // FONT2_H
